# outer test script for StatEye v5
# runs inner test script on each file in a directory that matches a pattern
# passes command-line arguments for key settings
# by Rob Elliott, HP
import fnmatch
import os
import time
import subprocess
 
rootPath = 'c:/pub/stateye/v5.071210'  # location of the .s4p files
#pattern = 'MiniSAS_one*.s4p' # Can include any UNIX shell-style wildcards

# run simulations with all combinations of the following
patterns = [ 'MiniSAS*.s4p', 'HP*.s4p' ]  # s4p filename(s)
pimins = [ '0' ]    # pimin settings (use '1' for certain cables)
deemps = [ '3', '2', '1', '0' ]  # deemphasis settings
dfes = [ '0', '3' ]  # dfetaps settings
scrambles = [ '0', '1' ]  # scrambled settings '0'=8b10b, '1'=random

for pattern in patterns:
    for root, dirs, files in os.walk(rootPath):
        for filename in files:
            if fnmatch.fnmatch(filename, pattern):
                print "Processing " + os.path.join(root, filename)
                for pimin in pimins:
                    for deemp in deemps:
                        for dfe in dfes:
                            for scramble in scrambles:
                                cmd = [\
                                    "c:/program files/python25/python.exe",\
                                    "testcase-071210-resub.py",\
                                    "-i", os.path.join(root, filename),\
                                    "-p", pimin,
                                    "-d", deemp,\
                                    "-r", dfe,\
                                    "-s", scramble,
                                    ]
                                tag = time.time()
                                print cmd
                                retcode = subprocess.call(cmd)
                                print 'Finished in %0.1f sec with retcode=%d'%(time.time()-tag, retcode)

